#include "cctk.h"

#define RHS_CONSERVE

module rhs_mine
use params
   
   contains
     
!-----------------------------------------------------------------
!
!
!-----------------------------------------------------------------
    subroutine calcrhs(RHS, u, v, dxu, dyu, dzu, dxv, dyv, dzv, w, par)
      implicit   none

      CCTK_REAL, dimension(NU), intent(out) :: RHS
      CCTK_REAL, dimension(NU), intent(in) :: u,dxu,dyu,dzu
      CCTK_REAL, dimension(NV), intent(in) :: dxv,dyv,dzv, v
      CCTK_REAL, dimension(NW), intent(in) :: w
      CCTK_REAL, dimension(NPAR),intent(in) :: par

      ! local vars

      CCTK_REAL, dimension(3) :: xx
      logical, parameter :: debug = .false.
      CCTK_INT ::  i, error
      ! abbreviations for the main vars
      CCTK_REAL :: phi,pi,d1phi,d2phi,d3phi
      CCTK_REAL :: dxFxpi,dyFypi,dzFzpi,dxFdphi,dyFdphi,dzFdphi
      CCTK_REAL :: dxpi,dypi,dzpi,dxd1phi,dyd2phi,dzd3phi
      
!----------------------------------------------------------------------------
!
!                    AUXILIARY VARS
!
!_____________________________________________________________________________

           
      xx(1) = w(H_XPHYS)
      xx(2) = w(H_YPHYS)
      xx(3) = w(H_ZPHYS)               
      
      phi   = u(H_PHI)
      d1phi = u(H_D1PHI)
      d2phi = u(H_D2PHI)
      d3phi = u(H_D3PHI)
      pi    = u(H_D4PHI)


      dxd1phi = dxu(H_D1PHI)
      dyd2phi = dyu(H_D2PHI)
      dzd3phi = dzu(H_D3PHI)
      
      dxpi    = dxu(H_D4PHI)
      dypi    = dyu(H_D4PHI)
      dzpi    = dzu(H_D4PHI)
    
            
      dxFxpi  = dxv(H_FXD4PHI)
      dyFypi  = dyv(H_FYD4PHI)
      dzFzpi  = dzv(H_FZD4PHI)

      dxFdphi  = dxv(H_FDPHI)
      dyFdphi  = dyv(H_FDPHI)
      dzFdphi  = dzv(H_FDPHI)

!----------------------------------------------------------------------------
!
!                                COMPUTE RHS
!
!_____________________________________________________________________________

!     in terms of the fluxes
      RHS(H_PHI) = pi
      RHS(H_D1PHI) = - dxFdphi
      RHS(H_D2PHI) = - dyFdphi
      RHS(H_D3PHI) = - dzFdphi      
      RHS(H_D4PHI) = - dxFxpi - dyFypi - dzFzpi 

!     in terms of the variables themselves
!      RHS(H_PHI) = pi
!      RHS(H_D1PHI) = dxpi
!      RHS(H_D2PHI) = dypi 
!      RHS(H_D3PHI) = dzpi
!      RHS(H_D4PHI) = dxd1phi + dyd2phi + dzd3phi

	   
      return
      end subroutine

end module
